unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, DB, TeEngine, TeeSubChart, ExtCtrls, TeeProcs, Chart,
  DBChart, StdCtrls;

type
  TForm1 = class(TForm)
    DBChart1: TDBChart;
    ChartTool1: TSubChartTool;
    BEditSubChart: TButton;
    Panel1: TPanel;
    BEditChart: TButton;
    procedure FormCreate(Sender: TObject);
    procedure DBChart1AfterDraw(Sender: TObject);
    procedure BEditSubChartClick(Sender: TObject);
    procedure BEditChartClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Series, TeCanvas, EditChar;

type
  TShapeAccess=class(TTeeCustomShape);
  TCustomTeePanelAccess=class(TCustomTeePanel);

var dbSubChart: TDBChart;

procedure TForm1.BEditChartClick(Sender: TObject);
begin
  EditChart(Self, DBChart1);
end;

procedure TForm1.BEditSubChartClick(Sender: TObject);
begin
  EditChart(Self, dbSubChart);
end;

procedure TForm1.DBChart1AfterDraw(Sender: TObject);

  {$IFNDEF FMX}
  procedure ApplyMetaScale(var R:TRect);
  var tmp : TRect;
      tmpR : TRect;
      tmpW,
      tmpH,
      tmpX,
      tmpY : Single;
  begin
    tmp:=TCustomChart(Parent).ChartPrintRect;
    tmpR:=TCustomChart(Parent).GetRectangle;

    tmpW:=(tmpR.Right-tmpR.Left);
    tmpX:=(tmp.Right-tmp.Left)/tmpW;

    R.Left:=Round(R.Left*tmpX);
    R.Right:=Round(R.Right*tmpX);

    tmpH:=(tmpR.Bottom-tmpR.Top);
    tmpY:=(tmp.Bottom-tmp.Top)/tmpH;

    R.Top:=Round(R.Top*tmpY);
    R.Bottom:=Round(R.Bottom*tmpY);
  end;
  {$ENDIF}

var t : Integer;
    tmp : TCanvas;
    tmpR : TRect;

    {$IFNDEF FMX}
    tmpScale : Boolean;
    {$ENDIF}
begin
  with dbSubChart do
  if Active and Visible and Assigned(Parent) then
  begin
    tmp:=TCustomChart(Parent).Canvas.ReferenceCanvas;

    {$IFNDEF FMX}
    tmpScale:=TCustomChart(Parent).Printing and
              TCustomChart(Parent).Canvas.Metafiling and
              TCustomTeePanelAccess(Parent).IsPrinterCanvas;
    {$ENDIF}

    BufferedDisplay:=False;

    tmpR:=BoundsRect;

    {$IFNDEF FMX}
    if tmpScale then
       ApplyMetaScale(tmpR);
    {$ENDIF}

    Draw(tmp,tmpR);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);

  procedure HideShape(const AShape:TTeeCustomShape);
  begin
    AShape.Hide;
    TShapeAccess(AShape).DefaultVisible:=False;
  end;

begin
  DBChart1.AddSeries(TBarSeries).FillSampleValues;

  //ChartTool1.Charts.AddChart('SubChart');

  dbSubChart:=TDBChart.Create(DBChart1);
  with dbSubChart do
  begin
    Parent:=DBChart1;
    BoundsRect:=TeeRect(50,50,200,150);

    HideShape(Legend);
    HideShape(Title);
    HideShape(Foot);
    HideShape(SubTitle);
    HideShape(SubFoot);
    BevelOuter:=bvNone;
    Color:=clNone;

    AddSeries(TLineSeries).FillSampleValues;
  end;
end;

end.
